;; $Id: ch5-3-traced.scm,v 1.4 1999/04/25 16:23:52 leavens Exp $

(load-quietly-from-lib "ch5-3.scm")
(load-quietly-from-lib "display-and-return")

;;; Figure 5.3.2 : page 150

(define eval-exp
  ;; TYPE: (-> (parsed-exp Environment) Expressed-Value)
  (lambda (exp env)
    (displayln "Calling eval-exp with exp = " exp " and env =")
    (pretty-print env)
    (newline)
    (display-and-return
     "Result of eval-exp = "
     (variant-case exp
       (lit (datum) (number->expressed datum))
       (varref (var) (denoted->expressed (apply-env env var)))
       (app (rator rands)
	    (let ((proc (expressed->procedure (eval-exp rator env)))
		  (args (eval-rands rands env)))
	      (apply-proc proc args)))
       (if (test-exp then-exp else-exp)
	   (if (true-value? (expressed->number (eval-exp test-exp env)))
	       (eval-exp then-exp env)
	       (eval-exp else-exp env)))
       (let (decls body)
	 (let ((vars (map decl->var decls))
	       (exps (map decl->exp decls)))
	   (let ((new-env (extend-env vars
				      (map expressed->denoted
					   (eval-rands exps env))
				      env)))
	     (eval-exp body new-env))))
       (proc (formals body) 
	     (procedure->expressed (make-closure formals body env)))
       (else (error "Invalid abstract syntax:" exp))))))
