;;; $Id: ch5-4-2-expressed-value.scm,v 1.1 1998/10/26 23:19:57 leavens Exp $

(load-quietly-from-lib "inject-extract.scm")

(define number->expressed
  ;; TYPE: (-> (number) Expressed-Value)
  inject)

(define procedure->expressed
  ;; TYPE: (-> (Procedure) Expressed-Value)
  inject)

(define list->expressed
  ;; TYPE: (-> ((list Expressed-Value)) Expressed-Value)
  inject)

(define void->expressed
  ;; TYPE: (-> (void) Expressed-Value)
  (lambda (x)
    (number->expressed 0)))

(define ch5-4-2-expressed-value:extract
  ;; TYPE: (-> ((-> (Expressed-Value) boolean) string) (-> (T) T))
  (extract-maker "expressed"))

(define expressed->number
  ;; TYPE: (-> (Expressed-Value) number)
  (ch5-4-2-expressed-value:extract number? "number"))

(define expressed->procedure
  ;; TYPE: (-> (Expressed-Value) Procedure)
  (ch5-4-2-expressed-value:extract procedure? "procedure"))

(define expressed->list
  ;; TYPE: (-> (Expressed-Value) (list Expressed-Value))
  (ch5-4-2-expressed-value:extract (lambda (x) (or (pair? x) (null? x)))
				 "list"))

(define denoted->expressed
  ;; TYPE: (-> (Denoted-Value) Expressed-Value)
  (lambda (dv) dv))

(define expressed->denoted
  ;; TYPE: (-> (Expressed-Value) Denoted-Value)
  (lambda (ev) ev))
