;;; $Id: ch5-7-1-expressed-value.scm,v 1.1 1998/10/26 16:40:40 leavens Exp $

(load-quietly-from-lib "inject-extract.scm")

(define number->expressed
  ;; TYPE: (-> (number) Expressed-Value)
  inject)

(define procedure-text->expressed
  ;; TYPE: (-> (Procedure-Text) Expressed-Value)
  inject)

(define list->expressed
  ;; TYPE: (-> ((list Expressed-Value)) Expressed-Value)
  inject)

(define void->expressed
  ;; TYPE: (-> (void) Expressed-Value)
  (lambda (x)
    (number->expressed 0)))

(define ch5-7-1-expressed-value:extract
  ;; TYPE: (-> ((-> (Expressed-Value) boolean) string) (-> (T) T))
  (extract-maker "expressed"))

(define expressed->number
  ;; TYPE: (-> (Expressed-Value) number)
  (ch5-7-1-expressed-value:extract number? "number"))

(define expressed->procedure-text
  ;; TYPE: (-> (Expressed-Value) Procedure-Text)
  (ch5-7-1-expressed-value:extract (lambda (x) (or (prim-proc? x)
						   (proc? x)))
				 "procedure-text"))

(define expressed->list
  ;; TYPE: (-> (Expressed-Value) (list Expressed-Value))
  (ch5-7-1-expressed-value:extract (lambda (x) (or (pair? x) (null? x)))
				 "list"))

(define denoted->expressed
  ;; TYPE: (-> (Denoted-Value) Expressed-Value)
  cell-ref)

(define expressed->denoted
  ;; TYPE: (-> (Expressed-Value) Denoted-Value)
  make-cell)
