;;; $Id: ch6-1-4-storable-value.scm,v 1.1 1998/11/11 18:02:09 leavens Exp $

(load-quietly-from-lib "inject-extract.scm")

(define number->storable
  ;; TYPE: (-> (number) Storable-Value)
  inject)

(define procedure->storable
  ;; TYPE: (-> (Procedure) Storable-Value)
  inject)

(define list->storable
  ;; TYPE: (-> ((list Storable-Value)) Storable-Value)
  inject)

(define ch6-1-4-storable-value:extract
  ;; TYPE: (-> ((-> (Storable-Value) boolean) string) (-> (T) T))
  (extract-maker "storable"))

(define storable->number
  ;; TYPE: (-> (Storable-Value) number)
  (ch6-1-4-storable-value:extract number? "number"))

(define storable->procedure
  ;; TYPE: (-> (Storable-Value) Procedure)
  (ch6-1-4-storable-value:extract (lambda (x) (or (prim-proc? x)
						  (closure? x)))
				  "procedure"))

(define storable->list
  ;; TYPE: (-> (Storable-Value) (list Storable-Value))
  (ch6-1-4-storable-value:extract (lambda (x) (or (pair? x) (null? x)))
				 "list"))

(define storable->denoted
  ;; TYPE: (-> (Storable-Value) Denoted-Value)
  make-cell)

(define expressed->storable
  ;; TYPE: (-> (Expressed-Value) Storable-Value)
  (lambda (ev)
    (cond
     ((number? ev) ev)
     ((or (proc? ev) (closure? ev)) ev)
     ((or (pair? ev) (null? ev)) ev)
     (else (error "expressed->storable passed bad value:" ev)))))

(define storable->expressed
  ;; TYPE: (-> (Storable-Value) Expressed-Value)
  (lambda (sv)
    sv))
