;;; $Id: ch6-2.tst,v 1.3 1998/12/02 19:33:46 leavens Exp $

(load-quietly-from-lib "run.scm")

(run-regression-tests-equal?
 `(
    ( (run "let p = proc (b) b[0] := 3
            in letarray a[2] in begin a[0] := 1; a[1] := 2; p(a); a[0] end")
       ==> 3 )
    ( (run
"letarray u[3]; v[2]
in begin
     u[0] := 5; u[1] := 6; u[2] := 4; v[0] := 3; v[1] := 8;
     let p = proc (x)
               begin
                 x[1] := 7;
                 x := v;
                 x[1] := 9
               end
     in begin
          p(u);
          list(u[0], u[1], v[0], v[1])
        end
   end")
    ==> (3 9 3 9) )
    ( (run
"let p = proc (x) x := 5
in let a = 3; 
       b = 4
   in begin
        p(a);
        p(b);
        +(a, b)
      end")
    ==> 10 )
    )
 )

(run-test-case
 `(run
"define swap =
      proc (x, y)
        let temp = 0 
        in begin temp := x; x := y; y := temp end"))

(run-test-case `(run "define c = 3"))

(run-regression-tests-equal?
 `(
   ( (run
"let b = 4 
    in begin
         swap(c, b);
         list(b, c)
       end")
     ==> (3 4) )
   ( (run
"let b = 2
 in letarray a[3]
    in begin
         a[1] := 5; 
         swap(a[1], b);
         list(a[1], b)
       end")
     ==> (2 5) )
   ( (run "
let c = 3; 
    p = proc (x) x := 5
in begin 
      p(add1(c));
      c
    end")
     ==> 3 )
   ( (run "
let b = 3;
        p = proc (x, y)
              begin
                x := 4;
                y
              end 
    in p(b, b)")
     ==> 4 )
   ( (run "
let swap2 =
      proc (x, y)
        begin
          x := +(x, y); y := -(x, y); x := -(x, y)
        end;
    b = 1;
    c = 2
in begin
    swap2(b, c);
    list(b, c)
   end")
     ==> (2 1) )
   ( (run "
let swap2 =
      proc (x, y)
        begin
          x := +(x, y); y := -(x, y); x := -(x, y)
        end;
    b = 1;
    c = 2
in begin
    swap2(b, b);
    b
   end")
     ==> 0)
   ( (run "
letarray a[3]; b[2]
in let p = proc(x,y) begin
                      y := b; x := 5
                     end
   in begin
       a[0] := 1; a[1] := 2; a[2] := 3;
       b[0] := 4; b[1] := 6;
       p(a[1], a);
       list(a[0],a[1],b[0],b[1])
      end")
     ==> (4 6 4 6) )
   )
 )
