;;; $Id: ch7-2-expressed-value.scm,v 1.2 1998/12/04 17:51:32 leavens Exp $

(load-quietly-from-lib "inject-extract.scm")

;;; Anonymous figure : page 218

(define-record instance (class i-vals))

;;; Anonymous figure : page 227

(define-record class (parent c-vars c-vals i-vars m-env))

(define number->expressed
  ;; TYPE: (-> (number) Expressed-Value)
  inject)

(define procedure->expressed
  ;; TYPE: (-> (Procedure) Expressed-Value)
  inject)

(define list->expressed
  ;; TYPE: (-> ((list Expressed-Value)) Expressed-Value)
  inject)

(define void->expressed
  ;; TYPE: (-> (void) Expressed-Value)
  (lambda (x)
    (number->expressed 0)))

(define open-method->expressed
  ;; TYPE: (-> (Open-Method) Expressed-Value)
  inject)

(define ch7-2-expressed-value:extract
  ;; TYPE: (-> ((-> (Expressed-Value) boolean) string) (-> (T) T))
  (extract-maker "expressed"))

(define expressed->number
  ;; TYPE: (-> (Expressed-Value) number)
  (ch7-2-expressed-value:extract number? "number"))

(define expressed->procedure
  ;; TYPE: (-> (Expressed-Value) Procedure)
  (ch7-2-expressed-value:extract (lambda (x) (or (prim-proc? x)
						 (closure? x)))
				 "procedure"))

(define expressed->list
  ;; TYPE: (-> (Expressed-Value) (list Expressed-Value))
  (ch7-2-expressed-value:extract (lambda (x) (or (pair? x) (null? x)))
				 "list"))

(define expressed->open-method
  ;; TYPE: (-> (Expressed-Value) Open-Method)
  (ch7-2-expressed-value:extract procedure? "procedure"))

(define denoted->expressed
  ;; TYPE: (-> (Denoted-Value) Expressed-Value)
  cell-ref)

(define expressed->denoted
  ;; TYPE: (-> (Expressed-Value) Denoted-Value)
  make-cell)
