;;; $Id: combinators.scm,v 1.3 1999/02/11 06:25:19 leavens Exp $
;;; AUTHOR: Gary T. Leavens

(define I ; TYPE: (-> (T) T)
  (lambda (x) x))

(define K ; TYPE: (-> (T) (-> (S) T))
  (lambda (x)
    (lambda (y) x)))

;;; The type for S isn't as polymorphic as it should be,
;;; but the type system used here doesn't allow it's true type to be expressed.
(define S ; TYPE: (-> ((-> (T) (-> (S) U))) (-> ((-> (T) S)) (-> (T) U)))
  (lambda (x)
    (lambda (y)
      (lambda (z)
	((x z) (y z))))))

(define B ; TYPE: (-> ((-> (S) U)) (-> ((-> (T) S)) (-> (T) U)))
  ((S (K S)) K))

(define zero
  (K I))

(define add1
  (S B))

(define D
  ;; EQUATIONS: (((D X) Y) zero) = X
  ;;            (((D X) Y) (add1 Z)) = Y
  ((S (K (S ((S (K S)) ((S (K (S I))) ((S (K K)) K)))))) ((S (K K)) K)))
