(define (first-negative lst do-if-none)
  ; effect: if there are no negative numbers in lst, call do-if-none,
  ;         otherwise return the first negative number in lst
  (cond
   ((null? lst) (do-if-none))
   ((negative? (car lst)) (car lst))
   (else (first-negative (cdr lst) do-if-none))))

(define (qr n d cont err)
  ; if d = 0, then call err with d as an argument,
  ; otherwise call cont with the quotient of n by d and the remainder
  (if (zero? d)
      (err d)
      (cont (quotient n d) (remainder n d))))

(qr 16 3 (lambda (q r) (+ q r)) (lambda (d) (write "oops")))
;Value: 6

(call-with-current-continuation
 (lambda (err-value)
   (qr 16 3 (lambda (q r) (+ q r)) err-value)))
;Value: 6

(call-with-current-continuation
 (lambda (err-value)
   (qr 16 0 (lambda (q r) (+ q r)) err-value)))
;Value: 0


(define (first-negative2 lst do-if-none)
  (call-with-current-continuation
   (lambda (exit)
     (for-each (lambda (x) (if (negative? x) (exit x)))
	       lst)
     (do-if-none lst))))

(first-negative2 '(1 2 -3 4 5) (lambda (x) (write "oops")))
;Value: -3

(first-negative2 '(1 2 3) (lambda (x) (write "oops")))
; writes "oops"
;No value
