;;; AUTHOR: Gary T. Leavens

(load-quietly-from-lib "vector-map.scm")

(define dot-notation ; TYPE: (-> (datum) datum)
  (lambda (arg)
    ; ENSURES: result is a list that, when evaluated gives the value arg,
    ;          but uses dot notation.
    (cond
     ((vector? arg) (vector-map dot-notation arg))
     ((not (pair? arg)) arg)
     (else (list (dot-notation (car arg))
		 '.
		 (dot-notation (cdr arg)))))))
