;; $Id: eval-form-cont.scm,v 1.2 1999/08/11 16:28:05 leavens Exp $

;; Evaluation of forms for interpreters with continuations

;; Note: you have to define parse, eval-exp, and syntax-expand
;; before using this!
;; This also requires the use of updateable-environments.scm.

;; Grammar:
;;         <form> ::= define <var> = exp
;;                  | definearray <var> [ <exp> ]
;;                  | <exp>

(define eval-form
  ; TYPE: (-> (parsed-form) Expressed-Value)
  (lambda (tree)
    (variant-case tree
      (define (var exp)
	(let ((expanded-exp (syntax-expand exp)))
	  (begin
	    (if (not (defined-env? init-env var))
		(update-env! init-env var (make-cell 0)))
	    (eval-exp (make-varassign var expanded-exp)
		      init-env
		      final-valcont))))
      (definearray (var len-exp)
	(let ((expanded-len (syntax-expand len-exp)))
	  (if (defined-env? init-env var)
	      ; using chapter 6 procedures ...
	      (denoted-value-assign! (apply-env init-env var)
				     (make-array
				      (eval-exp expanded-len
						init-env
						final-valcont)))
	      (set! init-env
		    (extend-env
		     (list var)
		     (list (do-letarray (eval-exp expanded-len
						  init-env
						  final-valcont)))
		     init-env)))))
      (else
       (eval-exp (syntax-expand tree)
		 init-env
		 final-valcont)))))

