;; $Id: eval-form-for-oop.scm,v 1.6 1998/12/04 17:51:32 leavens Exp $

;; Evaluation of forms for the object-oriented interpreters.

;; Note: you have to define parse, eval-exp, and syntax-expand
;; before using this!

;; Grammar:
;;         <form> ::= define <var> = exp
;;                  | <exp>

(define eval-form
  ;; TYPE: (-> (parsed-form) Expressed-Value)
  (lambda (tree)
    (let* ((no-class (make-nothing))
	   (no-inst (make-nothing)))
      (variant-case tree
	(define (var exp)
	  (let ((expanded-exp (syntax-expand exp)))
	    (begin
	      (if (not (defined-in-env? init-env var))
		  (set! init-env
			(extend-env (list var)
				    (list (make-cell (number->expressed 0)))
				    init-env)))
	      (eval-exp (make-varassign var expanded-exp)
			init-env
		        no-class
		        no-inst))))
	(else
	 (eval-exp (syntax-expand tree) init-env no-class no-inst))))))
