;; $Id: eval-form-with-define.scm,v 1.4 1998/11/11 18:02:09 leavens Exp $

;; Evaluation of forms

;; Note: you have to define parse, eval-exp, and syntax-expand
;; before using this!
;; This also requires the use of updateable-environments.scm.

;; Grammar:
;;         <form> ::= define <var> = exp
;;                  | definearray <var> [ <exp> ]
;;                  | <exp>

(define eval-form
  ;; TYPE: (-> (parsed-form) Expressed-Value)
  (lambda (tree)
    (variant-case tree
      (define (var exp)
	(let ((expanded-exp (syntax-expand exp)))
	  (begin
	    (if (not (defined-in-env? init-env var))
		(update-env! init-env var (make-cell 0)))
	    (eval-exp (make-varassign var expanded-exp) init-env))))
      (definearray (var len-exp)
	(let ((expanded-len (syntax-expand len-exp)))
	  (if (defined-in-env? init-env var)
	      ;; using chapter 6 procedures ...
	      (denoted-value-assign! (apply-env init-env var)
				     (make-array
				      (eval-exp expanded-len init-env)))
	      (set! init-env
		    (extend-env
		     (list var)
		     (list (do-letarray (eval-exp expanded-len init-env)))
		     init-env)))))
      (else
       (eval-exp (syntax-expand (form->exp tree)) init-env)))))
