;;; $Id: lambda-1-examples.scm,v 1.9 1999/01/22 17:04:16 leavens Exp $
;;; Examples in the language lambda-1.
;;; Grammar:
;;;  <lambda-1-exp> ::= <varref>
;;;                     | (lambda (<var>) <lambda-1-exp>)
;;;                     | (<lambda-1-exp> <lambda-1-exp>)
;;; <varref> ::= <var>
;;; <var> ::= <symbol>

(load-from-lib "lambda-1.scm")

(define count-varrefs  ; TYPE: (-> (lambda-1-exp) number)
  (lambda (exp)
    ;; ENSURES: result is the number of <varref>s in exp
    (if (varref? exp)
	1
	(if (lambda? exp)
	    (count-varrefs (lambda->body exp))
	    (+ (count-varrefs (app->rator exp))
	       (count-varrefs (app->rand exp)))))))

(define all-varrefs   ; TYPE: (-> (lambda-1-exp) (list symbol))
    (lambda (exp)
      ;; ENSURES: result is a list of all the <varref>s in exp
      ;;          (this list may contain duplicate occurrences of symbols).
      (if (varref? exp)
	(list (varref->var exp))
	(if (lambda? exp)
	    (all-varrefs (lambda->body exp))
	    (append (all-varrefs (app->rator exp))
		    (all-varrefs (app->rand exp)))))))

;;; Note: in class we did all-varrefs so it returned a set,
;;; so we used set-union instead of append.
