;;; $Id: lexical-addr.scm,v 1.1 1998/09/28 01:59:03 leavens Exp $
;;; An ADT for lexical addresses.  The grammar is as follows.
;;;
;;;     <lexical-addr> ::= ( <symbol> : <number> <number> )

(define lexical-addr?
  ;; TYPE: (-> (datum) boolean)
  (lambda (d)
    (and (list? d)
	 (= (length d) 4)
	 (symbol? (car d))
	 (eq? ': (cadr d))
	 (number? (caddr d))
	 (number? (cadddr d)))))

(define make-lexical-addr
  ;; TYPE: (-> (symbol number number) lexical-addr)
  (lambda (v d p)
    (list v ': d p)))

(define lexical-addr->name
  ;; TYPE: (-> (lexical-addr) symbol)
  car)

(define lexical-addr->depth
  ;; TYPE: (-> (lexical-addr) number)
  caddr)

(define lexical-addr->position
  ;; TYPE: (-> (lexical-addr) number)
  cadddr)

(define parse-lexical-addr
  ;; TYPE: (-> (datum) lexical-addr)
  (lambda (addr)
    (if (lexical-addr? addr)
	addr
	(error "parse-lexical-addr, syntax error in " addr))))
