;;; $Id: maybe.scm,v 1.3 1998/10/24 01:27:33 leavens Exp $
;;; tagged, discriminated union types

(define *maybe:maybe-tag* 'maybe)

(define maybe?
  ;; TYPE: (-> (datum) boolean)
  (lambda (d)
    (and (vector? d)
	 (eq? (vector-ref d 0) *maybe:maybe-tag*))))

(define make-something
  ;; TYPE: (-> (T) (maybe T))
  (lambda (d)
    (vector *maybe:maybe-tag* 'something d)))

(define make-nothing
  ;; TYPE: (-> () (maybe T))
  (lambda ()
    (vector *maybe:maybe-tag* 'nothing)))

(define maybe-something?
  ;; TYPE: (-> ((maybe T)) boolean)
  (lambda (o)
    (eq? (vector-ref o 1) 'something)))

(define maybe-nothing?
  ;; TYPE: (-> ((maybe T)) boolean)
  (lambda (o)
    (eq? (vector-ref o 1) 'nothing)))

(define something->value
  ;; TYPE: (-> ((maybe T)) T)
  (lambda (o)
    (if (maybe-something? o)
	(vector-ref o 2)
	(error "something->value passed nothing"))))

(define maybe-test
  ;; TYPE: (-> ((maybe T) (-> (T) U) (-> () U)) U)
  (lambda (o something-fun nothing-fun)
    (if (maybe-something? o)
	(something-fun (vector-ref o 2))
	(nothing-fun))))
