;;; $Id: or.scm,v 1.2 1998/10/07 19:06:24 leavens Exp $
;;; tagged, discriminated union types

(define *or:or-tag* 'or)

(define or?
  ;; TYPE: (-> (datum) boolean)
  (lambda (d)
    (and (vector? d)
	 (= 3 (vector-length d))
	 (eq? (vector-ref d 0) *or:or-tag*))))

(define make-left
  ;; TYPE: (-> (S) (or S T))
  (lambda (d)
    (vector '*or:or-tag* 'left d)))

(define make-right
  ;; TYPE: (-> (T) (or S T))
  (lambda (d)
    (vector '*or:or-tag* 'right d)))

(define or-is-left?
  ;; TYPE: (-> ((or S T)) boolean)
  (lambda (o)
    (eq? (vector-ref o 1) 'left)))

(define or-is-right?
  ;; TYPE: (-> ((or S T)) boolean)
  (lambda (o)
    (eq? (vector-ref o 1) 'right)))

(define or->left
  ;; TYPE: (-> ((or S T)) S)
  (lambda (o)
    (if (or-is-left? o)
	(vector-ref o 2)
	(error "or->left this object has tag right " o))))

(define or->right
  ;; TYPE: (-> ((or S T)) T)
  (lambda (o)
    (if (or-is-right? o)
	(vector-ref o 2)
	(error "or->right this object has tag left " o))))

(define or-case
  ;; TYPE: (-> ((or S T) (-> (S) U) (-> (T) U)) U)
  (lambda (o left-fun right-fun)
    (if (or-is-left? o)
	(left-fun (vector-ref o 2))
	(right-fun (vector-ref o 2)))))
