;; @(#)$Id: set-equal.scm,v 1.8 1999/08/11 16:28:12 leavens Exp $

;; tests for comparing homework answer sets based on equal?
;; Author: Gary T. Leavens

(define cs342:set-one-elem car)        ; TYPE: (-> ((set T)) T)
(define cs342:set-rest cdr)            ; TYPE: (-> ((set T)) (set T))
(define cs342:set-empty? null?)	       ; TYPE: (-> ((set T)) boolean)

(define cs342:set-member?	       ; TYPE: (-> (T (set T)) boolean)
  (lambda (e S)
    (and (not (cs342:set-empty? S))
	 (or (equal? e (cs342:set-one-elem S))
	     (cs342:set-member? e (cdr S))))))

(define cs342:set-equal?
  ;; TYPE: (-> ((set T) (set T)) boolean)
  (letrec
      ((set-subset?	                ; TYPE: (-> ((set T) (set T)) boolean)
	(lambda (S1 S2)
	  (or (cs342:set-empty? S1)
	      (and (cs342:set-member? (cs342:set-one-elem S1) S2)
		   (set-subset? (cs342:set-rest S1) S2))))))
    (lambda (S1 S2)
      (and (set-subset? S1 S2)
	   (set-subset? S2 S1)))))

(define cs342:left-protected-set-equal?
  ;; TYPE: (-> (datum (set T)) boolean)
  (lambda (actual expected)
    (and (cs342:set? actual)
	 (cs342:set-equal? actual expected))))

(define cs342:no-duplicates?
  ;; TYPE: (-> ((list T)) boolean)
  (lambda (ls)
    (or (null? ls)
	(and (not (member (car ls) (cdr ls)))
	     (cs342:no-duplicates? (cdr ls))))))

(define cs342:set?
  ;; TYPE: (-> (datum) boolean)
  (lambda (x)
    (and (list? x) (cs342:no-duplicates? x))))

(define cs342:set-of
  ;; TYPE: (-> (T ...) (set T))
  (lambda args
    (if (null? args)
	'()
	(let ((rest (apply cs342:set-of (cdr args))))
	  (if (cs342:set-member? (car args) rest)
	      rest
	      (cons (car args) rest))))))
