;;; $Id: stack.scm,v 1.3 1998/10/13 19:36:47 leavens Exp $

(load-quietly-from-lib "cell.scm")

(define stack?
  ;; TYPE: (-> (datum) boolean)
  (lambda (x)
    (and (cell? x)
	 (list? (cell-ref x)))))

(define make-stack
  ;; TYPE: (-> () (stack T))
  (lambda ()
    (make-cell '())))

(define stack-push!
  ;; TYPE: (-> (T (stack T)) void)
  (lambda (e stk)
    (cell-set! stk (cons e (cell-ref stk)))))

(define stack-pop!
  ;; TYPE: (-> ((stack T)) void)
  (lambda (stk)
    ;; REQUIRES: stk is not empty
    (cell-set! stk (cdr (cell-ref stk)))))

(define stack-top
  ;; TYPE: (-> ((stack T)) T)
  (lambda (stk)
    ;; REQUIRES: stk is not empty
    (car (cell-ref stk))))

(define stack-empty?
  ;; TYPE: (-> ((stack T)) boolean)
  (lambda (stk)
    (null? (cell-ref stk))))
