;;; Anonymous figure : page 252

(define-record prim-app (primitive rands))

;;; Figure 8.3.2 : page 256

(define simple?
  (lambda (exp)
    (and (not (app? exp))
         (andmap simple? (head-exps exp))
         (andmap simple? (tail-exps exp)))))

(define head-exps
  (lambda (exp)
    (variant-case exp
      (lit (datum) '())
      (varref (var) '())
      (if (test-exp then-exp else-exp) (list test-exp))
      (proc (formals body) '())
      (let (decls body) (map decl->exp decls))
      (letrec (decls body) (map decl->exp decls))
      (prim-app (primitive rands) rands)
      (app (rator rands) (cons rator rands)))))

(define tail-exps
  (lambda (exp)
    (variant-case exp
      (lit (datum) '())
      (varref (var) '())
      (if (test-exp then-exp else-exp) (list then-exp else-exp))
      (proc (formals body) '())
      (let (decls body) (list body))
      (letrec (decls body) (list body))
      (prim-app (primitive rands) '())
      (app (rator rands) '()))))

(define binding-vars
  (lambda (exp)
    (variant-case exp
      (let (decls body) (map decl->var decls))
      (letrec (decls body) (map decl->var decls))
      (else '()))))

;;; Anonymous figure : page 257 (recently added for 3rd printing)

(define tail-form?
  (lambda (exp)
    (variant-case exp
      (proc (formals body) (tail-form? body))
      (else (and (andmap (lambda (x) 
                           (and (simple? x) (tail-form? x)))
                         (head-exps exp))
                 (andmap tail-form? (tail-exps exp)))))))
